/// \file
/// Leapfrog time integrator

#ifndef __LEAPFROG_H
#define __LEAPFROG_H

#include "CoMDTypes.h"

double timestep(SimFlat* s, int n, real_t dt, Timers* perfTimer);
void computeForce(SimFlat* s, Timers* perfTimer);
void kineticEnergy(SimFlat* s, Timers* perfTimer);

/// Update local and remote link cells after atoms have moved.
void redistributeAtoms(SimFlat* sim, Timers* perfTimer);

#endif
