// Copyright (c) 2016 ETH-Zurich. All rights reserved.
// Use of this source code is governed by a BSD-style license that
// can be found in the LICENSE file.

#ifndef _CONFIG_H_635106f3226c46d3d114158785752466
#define _CONFIG_H_635106f3226c46d3d114158785752466

#include "global.h"

#if PROVIDER == PROVIDER_VERBS
	#include "node/verbs/verbs.h"

#elif PROVIDER == PROVIDER_OFI
	#include "node/fabric/ofi.h"

#else
	#error "unknown provider"
#endif
#include "thread/thread.h"
// #include "provider/self/self.h"

namespace tinympi {

// std::lock is only able to lock >2 locks. So we use a small wrapper...
template<class Lockable1, class... LockableN>
inline void lock_( Lockable1& lock1, LockableN&... lockn ) {
	std::lock(lock1, lockn...);
}
template<class Lockable1>
inline void lock_(Lockable1& lock1) {
	lock1.lock();
}


	namespace impl {

#if PROVIDER == PROVIDER_VERBS
		using NodeWrapper = tinympi::verbs::verbs_wrapper;
#elif PROVIDER == PROVIDER_OFI
		using NodeWrapper= tinympi::ofi::ofi_wrapper;
#endif
// 		using SelfWrapper = tinympi::self::self_wrapper;
		using Request = BaseRequest;
		using ThreadWrapper = tinympi::thread2thread::thread_wrapper;

	}
}

using TMPI_Request = tinympi::impl::Request*;


#endif //_CONFIG_H_

