// Copyright (c) 2016 ETH-Zurich. All rights reserved.
// Use of this source code is governed by a BSD-style license that
// can be found in the LICENSE file.

#include "verbs_eagerprovider.h"

namespace tinympi {
namespace verbs {
namespace impl {

	// we have a limited amount of eager send slots that can be used by
	// all endpoints
	EagerMessage*              EagerProvider::eager_send_slots_ = nullptr;
	// and the memory region
	ibv_mr*                    EagerProvider::eager_send_slots_mr_ = nullptr;

	//////////////////////////////
	// piggyback send buffer
	// this is used for explicit piggyback
	eager_message_status*      EagerProvider::piggyback_send_buffer_ = nullptr;
	// and its memory region
	ibv_mr*                    EagerProvider::piggyback_send_buffer_mr_ = nullptr;

	thread_local uint_fast16_t EagerProvider::eager_send_slots_start_ = 0;
	thread_local uint_fast16_t EagerProvider::eager_send_slots_head_ = 0;

} // END NAMESPACE impl
} // END NAMESPACE verbs
} // END NAMESPACE tinympi
