// Copyright (c) 2016 ETH-Zurich. All rights reserved.
// Use of this source code is governed by a BSD-style license that
// can be found in the LICENSE file.

#ifndef _VERBS_RDVRREADYMESSAGE_H_635106f3226c46d3d114158785752466
#define _VERBS_RDVRREADYMESSAGE_H_635106f3226c46d3d114158785752466

#include <atomic>

#include "verbs_config.h"

namespace tinympi {
namespace verbs {
namespace impl {

enum class rready_message_status : uint64_t {
	free,
	reserved,
	retrieved
};

//tinympi::verbs::impl::RdvRReadyMessage
struct RdvRReadyMessage {
	uint64_t send_request;                              // 8 byte
	uint64_t addr;                                      // 8 byte
	uint32_t rkey;                                      // 4 byte
	recvreqid_t recvreq_identifier;                     // 2 byte
	uint8_t reqpadding[2];
	volatile rready_message_status status;              // 4 byte
// 	uint8_t padding[4]; // padding such that sizeof(RdvRReadyMessage) % 32 == 0
};
constexpr size_t rdvRReadyMessageSendSize = sizeofMessage<RdvRReadyMessage>::value;

static_assert(std::is_standard_layout<RdvRReadyMessage>::value, "RdvRReadyMessage must be POD!");
static_assert(sizeof(RdvRReadyMessage) % 32 == 0, "Size should be multiple of 32!");

}
}
}

#endif //_VERBS_RDVSREADYMESSAGE_H_
