// Copyright (c) 2016 ETH-Zurich. All rights reserved.
// Use of this source code is governed by a BSD-style license that
// can be found in the LICENSE file.

#ifndef _VERBS_RDVSREADYMESSAGE_H_635106f3226c46d3d114158785752466
#define _VERBS_RDVSREADYMESSAGE_H_635106f3226c46d3d114158785752466

#include <atomic>

#include "global.h"
#include "verbs_config.h"

namespace tinympi {
namespace verbs {
namespace impl {

enum class sready_message_status : uint8_t {
	free,
	reserved,
	tobefreed,
	retrieved
};

//tinympi::verbs::impl::RdvSReadyMessage
struct RdvSReadyMessage {
	uint64_t send_request;                              // 8 byte
	global_id_t src_id;                                 // 8 byte
	local_id_t dest_id;                                 // 4 byte
	tag_t tag;                                          // 4 byte
	rid_t rid;                                          // 4 byte
	buflen_t buflen;                                    // 4 byte
	context_id_t context_id;                            // 2 byte
	volatile sready_message_status status;              // 1 byte DO NOT MOVE
	uint8_t padding[29]; // padding such that sizeof(RdvSReadyMessage) % 64 == 0
};
constexpr size_t rdvSReadyMessageSendSize = sizeofMessage<RdvSReadyMessage>::value;

static_assert(std::is_standard_layout<RdvSReadyMessage>::value, "RdvSReaydMessage must be POD!");
static_assert(sizeof(RdvSReadyMessage) % 64 == 0, "Size should be multiple of 64!");

} // END NAMESPACE impl
} // END NAMESPACE verbs
} // END NAMESPACE tinympi

#endif //_VERBS_RDVSREADYMESSAGE_H_
