// Copyright (c) 2016 ETH-Zurich. All rights reserved.
// Use of this source code is governed by a BSD-style license that
// can be found in the LICENSE file.

#ifndef _VERBS_REQUEST_H_635106f3226c46d3d114158785752466
#define _VERBS_REQUEST_H_635106f3226c46d3d114158785752466

#include "verbs_endpoint.h"
#include "provider_impl/baserequest.h"

namespace tinympi {
namespace verbs {
namespace impl {

using namespace tinympi::impl;

//tinympi::verbs::impl::verbs_request_types
enum class verbs_request_types : uint_fast8_t {
	VERBS_EAGERSEND,
	VERBS_EAGERRECV,
	VERBS_RDVSEND,
	VERBS_RDVRECV,
	VERBS_UNKNOWN
};

#define VERBS_REQUEST_MEMBERS \
	BASE_REQUEST_MEMBERS                    /* 56 */ \
	verbs_request_types verbs_request_type; /* >1 */ \
	VerbsEndpoint* endpoint                 /*  8 */ ;

//tinympi::verbs::impl::VerbsRequest
struct VerbsRequest {
	VERBS_REQUEST_MEMBERS
};
static_assert(std::is_standard_layout<VerbsRequest>::value, "VerbsRequest must be POD!");

REQUESTS_CONVERTIBLE(BaseRequest, VerbsRequest)

ASSERT_BASE_REQUEST_COMPATIBLE(VerbsRequest)

#define ASSERT_VERBS_REQUEST_COMPATIBLE(TYPE) \
	ASSERT_BASE_REQUEST_COMPATIBLE(TYPE) \
	VERIFY_COMPATIBILITY(VerbsRequest, TYPE, verbs_request_type) \
	VERIFY_COMPATIBILITY(VerbsRequest, TYPE, endpoint)

namespace verbsRequest {
	inline void init(VerbsRequest* req, verbs_request_types type) {
		baseRequest::init(TO_BaseRequest(req), provider_types::node2node);
		req->verbs_request_type = type;
	}
}

}
}
}

#endif //_VERBS_REQUEST_H_
