// Copyright (c) 2016 ETH-Zurich. All rights reserved.
// Use of this source code is governed by a BSD-style license that
// can be found in the LICENSE file.

#ifndef _VERBS_SENDREQUEST_H_635106f3226c46d3d114158785752466
#define _VERBS_SENDREQUEST_H_635106f3226c46d3d114158785752466

#include "utility/error.h"

#include "verbs_endpoint.h"
#include "verbs_request.h"

namespace tinympi {
namespace verbs {
namespace impl {

#define VERBS_SEND_REQUEST_MEMBERS \
	VERBS_REQUEST_MEMBERS    /* 72 */ \
	rid_t rid                /*  4 */ ;

//tinympi::verbs::impl::VerbsSendRequest
struct VerbsSendRequest {
	VERBS_SEND_REQUEST_MEMBERS
};
static_assert(std::is_standard_layout<VerbsSendRequest>::value, "VerbsSendRequest must be POD!");
REQUESTS_CONVERTIBLE(VerbsSendRequest, BaseRequest)
REQUESTS_CONVERTIBLE(VerbsSendRequest, VerbsRequest)

ASSERT_VERBS_REQUEST_COMPATIBLE(VerbsSendRequest)

#define ASSERT_VERBS_SENDREQUEST_COMPATIBLE(TYPE) \
	ASSERT_VERBS_REQUEST_COMPATIBLE(TYPE) \
	VERIFY_COMPATIBILITY(VerbsSendRequest, TYPE, rid)

namespace verbsSendRequest {

	inline void init(VerbsSendRequest* req, verbs_request_types rtype) {
		verbsRequest::init(TO_VerbsRequest(req), rtype);
	}

	inline bool fill_status(VerbsSendRequest*, TMPI_Status*) {
		return false;
	}

} // END NAMESPACE verbsSendRequest
} // END NAMESPACE impl
} // END NAMESPACE verbs
} // END NAMESPACE tinympi

#endif //_VERBS_SENDREQUEST_H_
