// Copyright (c) 2016 ETH-Zurich. All rights reserved.
// Use of this source code is governed by a BSD-style license that
// can be found in the LICENSE file.

#ifndef _THREAD_REQUEST_H_635106f3226c46d3d114158785752466
#define _THREAD_REQUEST_H_635106f3226c46d3d114158785752466

#include "provider_impl/baserequest.h"

namespace tinympi {
namespace thread2thread {
namespace impl {

using namespace tinympi::impl;

//tinympi::thread::impl::verbs_request_types
enum class thread_request_types {
	THREAD_SEND,
	THREAD_RECV
};

#define THREAD_REQUEST_MEMBERS \
	BASE_REQUEST_MEMBERS \
	thread_request_types thread_request_type;

//tinympi::thread::impl::ThreadRequest
struct ThreadRequest {
	THREAD_REQUEST_MEMBERS
};
static_assert(std::is_standard_layout<ThreadRequest>::value, "ThreadRequest must be POD!");

REQUESTS_CONVERTIBLE(ThreadRequest, BaseRequest)

ASSERT_BASE_REQUEST_COMPATIBLE(ThreadRequest)

#define ASSERT_THREAD_REQUEST_COMPATIBLE(TYPE) \
	ASSERT_BASE_REQUEST_COMPATIBLE(TYPE) \
	VERIFY_COMPATIBILITY(ThreadRequest, TYPE, thread_request_type)

namespace threadRequest {
	inline void init(ThreadRequest* req, thread_request_types type) {
		// no lock required
		baseRequest::init(TO_BaseRequest(req), provider_types::thread2thread);
		req->thread_request_type = type;
	}
}

} // END NAMESPACE impl
} // END NAMESPACE thread2thread
} // END NAMESPACE tinympi

#endif //_THREAD_REQUEST_H_
