// Copyright (c) 2016 ETH-Zurich. All rights reserved.
// Use of this source code is governed by a BSD-style license that
// can be found in the LICENSE file.

#ifndef _SCIBENCH_H_635106f3226c46d3d114158785752466
#define _SCIBENCH_H_635106f3226c46d3d114158785752466

#include <liblsb.h>

// #define USESCIBENCH
#define _LSB_REAL_RESET() \
	LSB_Res()
#define _LSB_RESET() \
	LSB_Rec(0)
#define _LSB_RECORD(i) \
	LSB_Rec(i)

#ifdef USESCIBENCH

	#define LSB_RESET() _LSB_RESET()
	#define LSB_RECORD(i) _LSB_RECORD(i)

#else
	#define LSB_RESET() do {} while(false)
	#define LSB_RECORD(i) do {} while(false)

#endif

namespace tinympi {

	///////////////

	#define VERBSWRAPPER_ISEND_STARTED                            100
	#define VERBSWRAPPER_ISEND_ACQUIREDLOCK                       101
	#define VERBSWRAPPER_ISEND_GENERATEDEAGERSENDREQUEST          102
	#define VERBSWRAPPER_ISEND_GENERATEDRDVSENDREQUEST            103

	#define VERBSWRAPPER_POSTEDREQUEST_STARTED                    200
	#define VERBSWRAPPER_POSTEDREQUEST_ACQUIREDVERBSLOCK          201
	#define VERBSWRAPPER_POSTEDREQUEST_ACQUIREDENDPOINTLOCK       202
	#define VERBSWRAPPER_POSTEDREQUEST_DISPATCHED                 203
	#define VERBSWRAPPER_POSTEDREQUEST_ADDEDTOWAITINGQUEUE        204

	#define VERBSWRAPPER_CANCELREQUEST_STARTED                    300
	#define VERBSWRAPPER_CANCELREQUEST_DONE                       301

	#define VERBS_SENDEXPLICITPIGGYBACK_STARTED                   400
	#define VERBS_SENDEXPLICITPIGGYBACK_DONE                      401

	#define VERBS_POLLCHANNELS_SREADYPOLLANDLOCKRECVSLOTS         500
	#define VERBS_POLLCHANNELS_SREADYFOUNDDONE                    501
	#define VERBS_POLLCHANNELS_SREADYNOTFOUNDDONE                 502
	#define VERBS_POLLCHANNELS_RREADYPOLL                         503
	#define VERBS_POLLCHANNELS_RREADYPOLLDONE                     504
	#define VERBS_POLLCHANNELS_EAGERPOLLANDLOCK                   505
	#define VERBS_POLLCHANNELS_EAGERFOUNDDONE                     506
	#define VERBS_POLLCHANNELS_EAGERNOTFOUNDDONE                  507

	#define VERBS_PROGRESS_POLLEDWC                               600
	#define VERBS_PROGRESS_WCHANDLED                              601
	#define VERBS_PROGRESS_RDVRETRIEVEDDATAHANDLED                602
	#define VERBS_PROGRESS_WCEAGERSENDDONE                        603
	#define VERBS_PROGRESS_WCRDVSENDDONE                          604
	#define VERBS_PROGRESS_WCRDVRECVDONE                          605

	#define VERBSWRAPPER_RECVORPOSTANYSOURCE_STARTED              700
	#define VERBSWRAPPER_RECVORPOSTANYSOURCE_FOUNDUNEXPECTED      701
	#define VERBSWRAPPER_RECVORPOSTANYSOURCE_ADDEDTOWAITING       702

	#define VERBS_RDVWAITINGSREADYTOSENDIGNRREADY_STARTED         800

	///////////////

	#define THREADWRAPPER_CANCELREQUEST_STARTED                  1000
	#define THREADWRAPPER_CANCELREQUEST_DONE                     1001

	#define THREADWRAPPER_ISEND_STARTED                          1100
	#define THREADWRAPPER_ISEND_FOUNDWAITINGREQUEST              1101
	#define THREADWRAPPER_ISEND_NOTRETRIEVEDFROMOTHER            1102
	#define THREADWRAPPER_ISEND_ANYSOURCERETRIEVED               1103
	#define THREADWRAPPER_ISEND_RETRIEVEDFROMOTHER               1104
	#define THREADWRAPPER_ISEND_CANCELLEDREQUEST                 1105
	#define THREADWRAPPER_ISEND_RETRIEVED                        1106
	#define THREADWRAPPER_ISEND_ADDEDTOUNEXPECTED                1107

	#define THREADWRAPPER_POSTEDREQUEST_STARTED                  1200
	#define THREADWRAPPER_POSTEDREQUEST_ACQUIREDTHREADLOCK       1201
	#define THREADWRAPPER_POSTEDREQUEST_FOUNDUNEXPECTED          1202
	#define THREADWRAPPER_POSTEDREQUEST_DISPATCHED               1203
	#define THREADWRAPPER_POSTEDREQUEST_ADDEDTOWAITING           1204

	#define THREADWRAPPER_RECVORPOSTANYSOURCE_STARTED            1300
	#define THREADWRAPPER_RECVORPOSTANYSOURCE_FOUNDUNEXPECTED    1301
	#define THREADWRAPPER_RECVORPOSTANYSOURCE_DISPATCHED         1302
	#define THREADWRAPPER_RECVORPOSTANYSOURCE_ADDEDTOWAITING     1303

	///////////////

	#define PT2PT_DELETEREQUEST_STARTED                          2000
	#define PT2PT_DELETEREQUEST_DONE                             2001

	#define PT2PT_IRECVANYSOURCE_STARTED                         2100
	#define PT2PT_IRECVANYSOURCE_ACQUIREDLOCKS                   2101
	#define PT2PT_IRECVANYSOURCE_THREADRECVD                     2102
	#define PT2PT_IRECVANYSOURCE_THREADPOSTED                    2103
	#define PT2PT_IRECVANYSOURCE_NODERECVD                       2104
	#define PT2PT_IRECVANYSOURCE_NODEDELETEDOTHERS               2105
	#define PT2PT_IRECVANYSOURCE_NODEDONE                        2106
	#define PT2PT_IRECVANYSOURCE_NODEPOSTED                      2107

	#define PT2PT_WAIT_STARTED                                   2200
	#define PT2PT_WAIT_DONE                                      2201

	#define PT2PT_WAITALL_STARTED                                2300
	#define PT2PT_WAITALL_CREDITSET                              2301
	#define PT2PT_WAITALL_DONE                                   2302

	///////////////

	#define TMPI_IRECV_DONE                                      3000
	#define TMPI_ISEND_DONE                                      3001
	#define TMPI_RECV_DONE                                       3002
	#define TMPI_SEND_DONE                                       3003
	#define TMPI_SENDRECV_DONE                                   3004
	#define TMPI_GETCOUNT_DONE                                   3005
	#define TMPI_BCAST_DONE                                      3006
	#define TMPI_WAITALL_DONE                                    3007
	#define TMPI_WAIT_DONE                                       3008
	#define TMPI_ALLREDUCE_DONE                                  3009
	#define TMPI_BARRIER_DONE                                    3010

	///////////////

	#define TASKS_YIELD_RETURNED                                10001

	///////////////

	void _lsb_init();
#if defined(USESCIBENCH) or defined(EXT_USESCIBENCH)
	#define lsb_init() _lsb_init()
#else
	#define lsb_init() while(false) {}
#endif

	inline void lsb_finalize() {
#if defined(USESCIBENCH) or defined(EXT_USESCIBENCH)
		LSB_Finalize();
#endif
	}

} // END NAMESPACE tinympi

#endif
