// Copyright (c) 2016 ETH-Zurich. All rights reserved.
// Use of this source code is governed by a BSD-style license that
// can be found in the LICENSE file.

#ifndef _TASKS_STACK_H_635106f3226c46d3d114158785752466
#define _TASKS_STACK_H_635106f3226c46d3d114158785752466

namespace tinympi {
namespace tasks {
namespace impl {

	// these are all inline assembly functions needed

	// stores the state of the maintask to dest_addr (stacktop identifies the top of the main
	// tasks' stack). From this function we will return when we call restore_stack. Therefore,
	// we return 0 when we called copy_stack, and we will return the 1 when we
	int copy_stack(void* stack, void* registers, void* retaddr, void* state,
			void* stacktop)
		asm("_copytaskstack");

	// activates another task with given info
	int gototask_(void** old_stack, void** new_stack, void** old_registers, void** new_registers,
			void* old_retaddr, void** new_retaddr)
		asm ("_gototask");

	inline int gototask(void** old_stack, void** new_stack, void** old_registers,
			void** new_registers, void** old_retaddr, void** new_retaddr) {
		asm volatile ( "" : : : "memory" );
		return gototask_(old_stack, new_stack, old_registers, new_registers, old_retaddr,
				new_retaddr);
	}

} // END NAMESPACE impl
} // END NAMESPACE tasks
} // END NAMESPACE tinympi

#endif //_TASKS_STACK_H_
